#!/bin/bash -xv

# applicationConfigureVM.sh is installed and runs at the end of the application rpm installation phase.
#Update sudoers for tomcat user
date
echo 'update sudoers'
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/usr/bin/yum' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/usr/bin/yum'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=(postgres)NOPASSWD:*/usr/bin/dropdb' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=(postgres)NOPASSWD:/usr/bin/dropdb'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=(postgres)NOPASSWD:*/usr/bin/pg_restore' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=(postgres)NOPASSWD:/usr/bin/pg_restore'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/sbin/reboot' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/sbin/reboot'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/sbin/shutdown' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/sbin/shutdown'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/sbin/service' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/sbin/service'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/sbin/chkconfig' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/sbin/chkconfig'>>/etc/sudoers; fi;
#if [ $(grep -c '%tomcat ALL=NOPASSWD:*/usr/sbin/vmtoolsd' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/usr/sbin/vmware-guestd'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/usr/sbin/vmtoolsd' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/usr/sbin/vmtoolsd'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/usr/bin/zip' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/usr/bin/zip'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/bin/chmod' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/bin/chmod'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/usr/bin/openssl' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/usr/bin/openssl'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/usr/sbin/timezone_config.sh' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/usr/sbin/timezone_config.sh'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/opt/Dell/scripts/encrypt.sh' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/opt/Dell/scripts/encrypt.sh'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/usr/sbin/timezone_restore.sh' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/usr/sbin/timezone_restore.sh'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/usr/sbin/link_timezone.sh' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/usr/sbin/link_timezone.sh'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/usr/sbin/ntpsetting_config.sh' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/usr/sbin/ntpsetting_config.sh'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/usr/sbin/ntp_setting_ticker_config.sh' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/usr/sbin/ntp_setting_ticker_config.sh'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/usr/sbin/importCustomerCert.sh' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/usr/sbin/importCustomerCert.sh'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/usr/sbin/importCert.exp' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/usr/sbin/importCert.exp'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/opt/Dell/scripts/backup-puppet.sh' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/opt/Dell/scripts/backup-puppet.sh'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/opt/Dell/scripts/backup-clean.sh' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/opt/Dell/scripts/backup-clean.sh'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/opt/Dell/scripts/restore-clean.sh' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/opt/Dell/scripts/restore-clean.sh'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/opt/Dell/scripts/restore-puppet.sh' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/opt/Dell/scripts/restore-puppet.sh'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/tmp/encrypt-puppet.sh' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/tmp/encrypt-puppet.sh'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/tmp/zipLogs.sh' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/tmp/zipLogs.sh'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/opt/puppet/bin/puppet' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/opt/puppet/bin/puppet'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/opt/Dell/scripts/getPuppetModuleDetails.sh' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/opt/Dell/scripts/getPuppetModuleDetails.sh'>>/etc/sudoers; fi;
if [ $(grep -c '%tomcat ALL=NOPASSWD:*/opt/Dell/scripts/razor-repo-helper.sh' /etc/sudoers) -eq 0 ]; then echo '%tomcat ALL=NOPASSWD:/opt/Dell/scripts/razor-repo-helper.sh'>>/etc/sudoers; fi;
if [ $(grep -c '%razor ALL=NOPASSWD:*/opt/puppet/bin/puppet' /etc/sudoers) -eq 0 ]; then echo '%razor ALL=NOPASSWD:/opt/puppet/bin/puppet'>>/etc/sudoers; fi;
if [ $(grep -c '%razor ALL=NOPASSWD:*/opt/Dell/scripts/rm-device-ssl.sh' /etc/sudoers) -eq 0 ]; then echo '%razor ALL=NOPASSWD:/opt/Dell/scripts/rm-device-ssl.sh'>>/etc/sudoers; fi;

# Add /opt/puppet/bin to the secure_path or those commands will not be available when run under sudo
sed -i -e 's,secure_path = /sbin:/bin:/usr/sbin:/usr/bin,secure_path = /sbin:/bin:/usr/sbin:/usr/bin:/opt/puppet/bin,' /etc/sudoers

# Setup nfs share
date
echo 'setup nfs share'
mkdir -p /var/nfs
chmod 777 /var/nfs
if [ $(grep -c 'STATD_PORT=4001' /etc/sysconfig/nfs) -eq 0 ]; then echo 'STATD_PORT=4001' >>/etc/sysconfig/nfs; fi;
if [ $(grep -c 'LOCKD_TCPPORT=4002' /etc/sysconfig/nfs) -eq 0 ]; then echo 'LOCKD_TCPPORT=4002' >>/etc/sysconfig/nfs; fi;
if [ $(grep -c 'LOCKD_UDPPORT=4002' /etc/sysconfig/nfs) -eq 0 ]; then echo 'LOCKD_UDPPORT=4002' >>/etc/sysconfig/nfs; fi;
if [ $(grep -c 'MOUNTD_PORT=4003' /etc/sysconfig/nfs) -eq 0 ]; then echo 'MOUNTD_PORT=4003' >>/etc/sysconfig/nfs; fi;
if [ $(grep -c '/var/nfs        *(ro,sync,no_subtree_check)' /etc/exports) -eq 0 ]; then echo '/var/nfs        *(ro,sync,no_subtree_check)' >>/etc/exports; fi;

# ASM-3604 Increase heap size for pe-puppetdb
if [ $(grep -c 'Xmx192m' /etc/sysconfig/pe-puppetdb) != 0 ]; then sed -i -e 's/Xmx192m/Xmx512m/' /etc/sysconfig/pe-puppetdb; fi

chkconfig rpcbind on
chkconfig nfslock on
chkconfig smb on
chkconfig nmb on

cd /var
date
if [ ! -f /etc/samba/smb.conf ] || [ $(grep -c '/var/lib/razor/repo-store' /etc/samba/smb.conf) -eq 0 ]
then
   # these changes are applied as part of 7.5.0 build 1628 and only need to be applied once.

    find nfs -exec chgrp nobody {} \;
    find nfs -exec chmod 755 {} \;
    find nfs -exec chown tomcat {} \;
    echo '/var/nfs        *(rw,sync,no_subtree_check)' >/etc/exports
    echo tomcat ALL=NOPASSWD: /bin/mount, /bin/umount>>/etc/sudoers
    echo '[global]'                                        >/etc/samba/smb.conf
    echo 'security = share'                               >>/etc/samba/smb.conf
    echo '        workgroup = MYGROUP'                    >>/etc/samba/smb.conf
    echo '        server string = Samba Server Version %v'>>/etc/samba/smb.conf
    echo '        hosts allow = *'                        >>/etc/samba/smb.conf
    echo '        log file = /var/log/samba/log.%m'       >>/etc/samba/smb.conf
    echo '        max log size = 50'                      >>/etc/samba/smb.conf
    echo '        load printers = yes'                    >>/etc/samba/smb.conf
    echo '        cups options = raw'                     >>/etc/samba/smb.conf
    echo '[homes]'                                        >>/etc/samba/smb.conf
    echo '        comment = Home Directories'             >>/etc/samba/smb.conf
    echo '        browseable = no'                        >>/etc/samba/smb.conf
    echo '        writable = yes'                         >>/etc/samba/smb.conf
    echo '[razor]'                                        >>/etc/samba/smb.conf
    echo '  comment   = Windows Installers'               >>/etc/samba/smb.conf
    echo '  path      = /var/lib/razor/repo-store'        >>/etc/samba/smb.conf
    echo '  public = yes'                                 >>/etc/samba/smb.conf
    echo '  writable  = no'                               >>/etc/samba/smb.conf
    echo '  browsable = yes'                              >>/etc/samba/smb.conf
    echo '  read only = yes'                              >>/etc/samba/smb.conf


    date
    echo 'configure firewall'
    /usr/sbin/lokkit -q -p 111:tcp --update
    /usr/sbin/lokkit -q -p 111:udp --update
    /usr/sbin/lokkit -q -p 2049:udp --update
    /usr/sbin/lokkit -q -p 2049:tcp --update
    /usr/sbin/lokkit -q -p 4045:udp --update
    /usr/sbin/lokkit -q -p 4045:tcp --update
    /usr/sbin/lokkit -q -p 4001:tcp --update
    /usr/sbin/lokkit -q -p 4001:udp --update
    /usr/sbin/lokkit -q -p 4002:tcp --update
    /usr/sbin/lokkit -q -p 4002:udp --update
    /usr/sbin/lokkit -q -p 4003:tcp --update
    /usr/sbin/lokkit -q -p 4003:udp --update
    /usr/sbin/lokkit -q -p 4004:tcp --update
    /usr/sbin/lokkit -q -p 4004:udp --update

    # related to samba
    /usr/sbin/lokkit -q -p 137:udp --update
    /usr/sbin/lokkit -q -p 138:udp --update
    /usr/sbin/lokkit -q -p 139:tcp --update
    /usr/sbin/lokkit -q -p 445:tcp --update

    # open up puppet ports
    /usr/sbin/lokkit -q -p 61616:udp --update
    /usr/sbin/lokkit -q -p 61616:tcp --update
    /usr/sbin/lokkit -q -p 61613:udp --update
    /usr/sbin/lokkit -q -p 61613:tcp --update
    /usr/sbin/lokkit -q -p 8140:udp --update
    /usr/sbin/lokkit -q -p 8140:tcp --update
    /usr/sbin/lokkit -q -p 8080:udp --update
    /usr/sbin/lokkit -q -p 8080:tcp --update
    #/usr/sbin/lokkit -q -p 8081:udp --update
    #/usr/sbin/lokkit -q -p 8081:tcp --update
    /usr/sbin/lokkit -q -p 8082:udp --update
    /usr/sbin/lokkit -q -p 8082:tcp --update
    /usr/sbin/lokkit -q -p 8161:udp --update
    /usr/sbin/lokkit -q -p 8161:tcp --update
    /usr/sbin/lokkit -q -p 3000:udp --update
    /usr/sbin/lokkit -q -p 3000:tcp --update


    # set owner of tftp root to tomcat
    /bin/chown -R tomcat.tomcat /var/lib/tftpboot
    # open tftp port for udp traffic
    echo "=================================================="
    echo "= iptables before opening port 69 using lokkit   ="
    echo "=================================================="
    /sbin/iptables --list
    /usr/sbin/lokkit -p 69:udp --update
    echo "=================================================="
    echo "= iptables after opening port 69 using lokkit    ="
    echo "=================================================="
    /sbin/iptables --list
    # turn on nfs, tftp and autofs services when appliance boots
    date
    echo 'turn on tftp, nfs and autofs at boot'
    /sbin/chkconfig --level 345 tftp on
    /sbin/chkconfig --level 345 nfs on
    /sbin/chkconfig --level 345 autofs on
    /sbin/chkconfig

    # open ntpd port for udp traffic
    /usr/sbin/lokkit --custom-rules /opt/Dell/scripts/lokkit-custom-rules --update -v
    echo "=================================================="
    echo "= iptables after opening ntp port                ="
    echo "=================================================="
    # redirect snmp traffic on privileged 162 port to unprivileged 11620 port where it can be
    # consumed by the tomcat user from a webapp
    /usr/sbin/lokkit --custom-rules=ipv4:nat:/opt/Dell/scripts/lokkit-custom-rules-nat --update -v
    /sbin/iptables --list -n
    /sbin/iptables -L -vt nat -n

    # snmp configuration
    date
    echo 'snmp configuration (disabled)'
    # Disabling SNMP services until such time as ASM may need them. Snmpd was
    # reported as a medium information disclosure vulnerability by the NCC audit.
#    /usr/sbin/lokkit -q -p 161:tcp --update
#    /usr/sbin/lokkit -q -p 161:udp --update
#    /usr/sbin/lokkit -q -p 162:tcp --update
#    /usr/sbin/lokkit -q -p 16 vczx2:udp --update
    /sbin/chkconfig snmpd off
    /sbin/chkconfig snmptrapd off
    cd /etc/snmp
    patch </opt/Dell/scripts/snmpd.conf.patch

    # Disable nagios web admin console, per NCC security audit
    # Check if there are un-commented <Directory> entries in the nagios.conf
    if ! grep '<Directory' /etc/httpd/conf.d/nagios.conf | grep -e '^#' > /dev/null; then
        # Prepend comment
        sed -i '1s/^/# DISABLED BY Dell-ASM-ApplicationConfigureVM\n\n/' /etc/httpd/conf.d/nagios.conf

        # Comment out all lines
        sed -i 's/^\(.\)/#\1/g' /etc/httpd/conf.d/nagios.conf

        service httpd reload
    fi

    # set clock to UTC
    if [ -f /etc/sysconfig/clock ]
    then
      echo 'not changing clock config, as it already exists'
    else
      echo 'UTC=true'>/etc/sysconfig/clock
      echo 'ZONE="UTC"'>>/etc/sysconfig/clock
      cp /usr/share/zoneinfo/UTC /etc/localtime
      /sbin/hwclock --systohc --utc
      echo 'changed clock to UTC'
    fi

    date
    echo 'use semanage to allow http traffic to and between certain ports'
    # tell selinux that it is ok for httpd to use port 8010
    semanage port -a -t http_port_t -p tcp 8010
    # port 9010 was previously assigned in i18n port type. adding to http_port_t
    semanage port -m -t http_port_t -p tcp 9010
    # port 9080 was previously assigned ocsp port type. adding to http_port_t
    semanage port -m -t http_port_t -p tcp 9080
    semanage port -a -t http_port_t -p tcp 61616
    semanage port -a -t http_port_t -p tcp 61613
    # 8140 is already listed as puppet_port_t, adding to http_port_t
    semanage port -m -t http_port_t -p tcp 8140
    # 8080 is already listed as http_cache_port_t, adding to http_port_t
    semanage port -m -t http_port_t -p tcp 8080
    # 8081 is already listed as transproxy_port_t, adding to http_port_t
    semanage port -m -t http_port_t -p tcp 8081
    semanage port -a -t http_port_t -p tcp 8082
    semanage port -a -t http_port_t -p tcp 8161
    # 3000 is already listed as ntop_port_t, adding to http_port_t
    semanage port -m -t http_port_t -p tcp 3000
    semanage port -a -t http_port_t -p tcp 7080
    semanage port -a -t http_port_t -p tcp 7081

    # point dell_app_init console menu to the EULA

    if [ -f /etc/dell_app_init/dell_app_init.conf ]
    then
      sed -i 's:eula_text_filename = .*EULA:eula_text_filename = /opt/Dell/EULA:g' /etc/dell_app_init/dell_app_init.conf
      sed -i 's:#eula_input_version_file =:eula_input_version_file = /opt/Dell/eula_version:' /etc/dell_app_init/dell_app_init.conf
    fi

    #/etc/modprobe.d/appliance.conf file has a line 'install udf /bin/true'
    #For security purposes that line was added to limit the filesystems enabled in the appliance.
    #Removing that line, will let udf module to be loaded and the your mount command will work.
    #while mouting the ISO, run mount -t udf -o loop /var/lib/razor/repo-store/en_windows_server_2012_x64_dvd_915478.iso /tmp/mnt
    sed -i '/udf/d' /etc/modprobe.d/appliance.conf

    #Fix the ruby plugin for vim
    echo 'set shell=/bin/sh' >> /etc/vimrc
fi

# Older builds installed the python paramiko library from source, which conflicts
# with the CentOS rpm version which is needed by Nagios NRPE rpms. So the paramiko
# library is now installed form rpm and we have to remove the old one here
rm -rf /usr/lib/python2.6/site-packages/paramiko-1.7.7.1-py2.6.egg/
